<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::Logger Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1Logger.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1Logger-members.html">List of all members</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::Logger Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This is a singleton class (single instance) for logging messages and controlling how those messages are presented to the user.  
 <a href="classOpenSim_1_1Logger.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a3dcb06837a4266a621f7609c7ae9f063"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a3dcb06837a4266a621f7609c7ae9f063">Logger</a> ()=delete</td></tr>
<tr class="memdesc:a3dcb06837a4266a621f7609c7ae9f063"><td class="mdescLeft">&#160;</td><td class="mdescRight">This is a static singleton class: there is no way of constructing it.  <a href="classOpenSim_1_1Logger.html#a3dcb06837a4266a621f7609c7ae9f063">More...</a><br /></td></tr>
<tr class="separator:a3dcb06837a4266a621f7609c7ae9f063"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:ab9bf77d271bae9aa6b904d4b71a0038b"><td class="memItemLeft" align="right" valign="top">enum class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">Level</a> { <br />
&#160;&#160;<a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038bad15305d7a4e34e02489c74a5ef542f36">Off</a> = 6
, <a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038ba278d01e5af56273bae1bb99a98b370cd">Critical</a> = 5
, <a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038ba902b0d55fddef6f8d651fe1035b7d4bd">Error</a> = 4
, <a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038ba56525ae64d370c0b448ac0d60710ef17">Warn</a> = 3
, <br />
&#160;&#160;<a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038ba4059b0251f66a18cb56f544728796875">Info</a> = 2
, <a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038baa603905470e2a5b8c13e96b579ef0dba">Debug</a> = 1
, <a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038badd4ec0ac4e58f7c32a01244ae91150b1">Trace</a> = 0
<br />
 }</td></tr>
<tr class="memdesc:ab9bf77d271bae9aa6b904d4b71a0038b"><td class="mdescLeft">&#160;</td><td class="mdescRight">This enum lists the types of messages that should be logged.  <a href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">More...</a><br /></td></tr>
<tr class="separator:ab9bf77d271bae9aa6b904d4b71a0038b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:aebdf27ba090612d28271dfcd74e2944a"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#aebdf27ba090612d28271dfcd74e2944a">setLevel</a> (<a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">Level</a> level)</td></tr>
<tr class="memdesc:aebdf27ba090612d28271dfcd74e2944a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Log messages of importance <code>level</code> and greater.  <a href="classOpenSim_1_1Logger.html#aebdf27ba090612d28271dfcd74e2944a">More...</a><br /></td></tr>
<tr class="separator:aebdf27ba090612d28271dfcd74e2944a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca506597a87dafa7d5af8451377a7da6"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">Level</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#aca506597a87dafa7d5af8451377a7da6">getLevel</a> ()</td></tr>
<tr class="separator:aca506597a87dafa7d5af8451377a7da6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cb7dc306a537291f77996c207bc20d3"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a4cb7dc306a537291f77996c207bc20d3">setLevelString</a> (std::string level)</td></tr>
<tr class="memdesc:a4cb7dc306a537291f77996c207bc20d3"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classOpenSim_1_1Set.html" title="A class for holding a set of pointers to objects.">Set</a> the logging level using one of the following strings (case-insensitive):  <a href="classOpenSim_1_1Logger.html#a4cb7dc306a537291f77996c207bc20d3">More...</a><br /></td></tr>
<tr class="separator:a4cb7dc306a537291f77996c207bc20d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa4f14f9ad998e048cda9beddfc7d088f"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#aa4f14f9ad998e048cda9beddfc7d088f">getLevelString</a> ()</td></tr>
<tr class="separator:aa4f14f9ad998e048cda9beddfc7d088f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2208167a9d1c1b48ed4e54a161d679a"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ae2208167a9d1c1b48ed4e54a161d679a">shouldLog</a> (<a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">Level</a> level)</td></tr>
<tr class="memdesc:ae2208167a9d1c1b48ed4e54a161d679a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if messages at the provided level should be logged, based on the set logging level.  <a href="classOpenSim_1_1Logger.html#ae2208167a9d1c1b48ed4e54a161d679a">More...</a><br /></td></tr>
<tr class="separator:ae2208167a9d1c1b48ed4e54a161d679a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada23d4a22bda1b8c8720467340705390"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ada23d4a22bda1b8c8720467340705390">addFileSink</a> (const std::string &amp;filepath=&quot;opensim.log&quot;)</td></tr>
<tr class="memdesc:ada23d4a22bda1b8c8720467340705390"><td class="mdescLeft">&#160;</td><td class="mdescRight">Log messages to a file at the level <a class="el" href="classOpenSim_1_1Logger.html#aca506597a87dafa7d5af8451377a7da6">getLevel()</a>.  <a href="classOpenSim_1_1Logger.html#ada23d4a22bda1b8c8720467340705390">More...</a><br /></td></tr>
<tr class="separator:ada23d4a22bda1b8c8720467340705390"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd269e7508f0a8d41002db2bd5e2758b"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#acd269e7508f0a8d41002db2bd5e2758b">removeFileSink</a> ()</td></tr>
<tr class="memdesc:acd269e7508f0a8d41002db2bd5e2758b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove the filesink if it exists.  <a href="classOpenSim_1_1Logger.html#acd269e7508f0a8d41002db2bd5e2758b">More...</a><br /></td></tr>
<tr class="separator:acd269e7508f0a8d41002db2bd5e2758b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa6abb842a363b6e596d5a2748f5f19f1"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#aa6abb842a363b6e596d5a2748f5f19f1">addSink</a> (const std::shared_ptr&lt; <a class="el" href="classOpenSim_1_1LogSink.html">LogSink</a> &gt; sink)</td></tr>
<tr class="memdesc:aa6abb842a363b6e596d5a2748f5f19f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start reporting messages to the provided sink.  <a href="classOpenSim_1_1Logger.html#aa6abb842a363b6e596d5a2748f5f19f1">More...</a><br /></td></tr>
<tr class="separator:aa6abb842a363b6e596d5a2748f5f19f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ed6dc7413d3bd5f1a1e61e54db4ffa8"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a4ed6dc7413d3bd5f1a1e61e54db4ffa8">removeSink</a> (const std::shared_ptr&lt; <a class="el" href="classOpenSim_1_1LogSink.html">LogSink</a> &gt; sink)</td></tr>
<tr class="memdesc:a4ed6dc7413d3bd5f1a1e61e54db4ffa8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a sink.  <a href="classOpenSim_1_1Logger.html#a4ed6dc7413d3bd5f1a1e61e54db4ffa8">More...</a><br /></td></tr>
<tr class="separator:a4ed6dc7413d3bd5f1a1e61e54db4ffa8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">Commands to log messages</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p>Use these functions instead of using spdlog directly. </p>
</div></td></tr>
<tr class="memitem:a8ae1892878df36703af38b369b11e0ca"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:a8ae1892878df36703af38b369b11e0ca"><td class="memTemplItemLeft" align="right" valign="top">static void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a8ae1892878df36703af38b369b11e0ca">critical</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:a8ae1892878df36703af38b369b11e0ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a250f3b0db87ffb351e1922d6ddfa4952"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:a250f3b0db87ffb351e1922d6ddfa4952"><td class="memTemplItemLeft" align="right" valign="top">static void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a250f3b0db87ffb351e1922d6ddfa4952">error</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:a250f3b0db87ffb351e1922d6ddfa4952"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9fb1e1e532b51620a732cee20f008ec6"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:a9fb1e1e532b51620a732cee20f008ec6"><td class="memTemplItemLeft" align="right" valign="top">static void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a9fb1e1e532b51620a732cee20f008ec6">warn</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:a9fb1e1e532b51620a732cee20f008ec6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a686643c76023df13e6e21e9006ed2c8a"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:a686643c76023df13e6e21e9006ed2c8a"><td class="memTemplItemLeft" align="right" valign="top">static void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a686643c76023df13e6e21e9006ed2c8a">info</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:a686643c76023df13e6e21e9006ed2c8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa471cfeb37b39908214760efb4c45446"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:aa471cfeb37b39908214760efb4c45446"><td class="memTemplItemLeft" align="right" valign="top">static void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#aa471cfeb37b39908214760efb4c45446">debug</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:aa471cfeb37b39908214760efb4c45446"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad981c195465d109877d26430dc93f13a"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:ad981c195465d109877d26430dc93f13a"><td class="memTemplItemLeft" align="right" valign="top">static void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ad981c195465d109877d26430dc93f13a">trace</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:ad981c195465d109877d26430dc93f13a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79ed78dd4d35d61dded99abc5bbe385f"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:a79ed78dd4d35d61dded99abc5bbe385f"><td class="memTemplItemLeft" align="right" valign="top">static void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a79ed78dd4d35d61dded99abc5bbe385f">cout</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="memdesc:a79ed78dd4d35d61dded99abc5bbe385f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Use this function to log messages that would normally be sent to std::cout.  <a href="classOpenSim_1_1Logger.html#a79ed78dd4d35d61dded99abc5bbe385f">More...</a><br /></td></tr>
<tr class="separator:a79ed78dd4d35d61dded99abc5bbe385f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="related"></a>
Related Functions</h2></td></tr>
<tr><td class="ititle" colspan="2"><p>(Note that these are not member functions.) </p>
</td></tr>
<tr><td colspan="2"><div class="groupHeader">Logging functions</div></td></tr>
<tr class="memitem:ad5a89a3ecbe0b1a88eae7dccf73af2b0"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:ad5a89a3ecbe0b1a88eae7dccf73af2b0"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ad5a89a3ecbe0b1a88eae7dccf73af2b0">log_critical</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:ad5a89a3ecbe0b1a88eae7dccf73af2b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab56a381bdaf340f6bc58ab73a67de4a8"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:ab56a381bdaf340f6bc58ab73a67de4a8"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ab56a381bdaf340f6bc58ab73a67de4a8">log_error</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:ab56a381bdaf340f6bc58ab73a67de4a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83e8a51160dc02d15543381e38405651"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:a83e8a51160dc02d15543381e38405651"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a83e8a51160dc02d15543381e38405651">log_warn</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:a83e8a51160dc02d15543381e38405651"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4d15dcdc1d233ba73afca5adfcc7cd2"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:ac4d15dcdc1d233ba73afca5adfcc7cd2"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ac4d15dcdc1d233ba73afca5adfcc7cd2">log_info</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:ac4d15dcdc1d233ba73afca5adfcc7cd2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae68b6746c2a1650da00a270e54334bd3"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:ae68b6746c2a1650da00a270e54334bd3"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ae68b6746c2a1650da00a270e54334bd3">log_debug</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:ae68b6746c2a1650da00a270e54334bd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae48973bbd459ae7f2e3f3644a798028e"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:ae48973bbd459ae7f2e3f3644a798028e"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#ae48973bbd459ae7f2e3f3644a798028e">log_trace</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="separator:ae48973bbd459ae7f2e3f3644a798028e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f653d7d131bf90fe00c293b9cfd9d26"><td class="memTemplParams" colspan="2">template&lt;typename... Args&gt; </td></tr>
<tr class="memitem:a4f653d7d131bf90fe00c293b9cfd9d26"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1Logger.html#a4f653d7d131bf90fe00c293b9cfd9d26">log_cout</a> (spdlog::string_view_t fmt, const Args &amp;... args)</td></tr>
<tr class="memdesc:a4f653d7d131bf90fe00c293b9cfd9d26"><td class="mdescLeft">&#160;</td><td class="mdescRight">Use this function to log messages that would normally be sent to std::cout.  <a href="classOpenSim_1_1Logger.html#a4f653d7d131bf90fe00c293b9cfd9d26">More...</a><br /></td></tr>
<tr class="separator:a4f653d7d131bf90fe00c293b9cfd9d26"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>This is a singleton class (single instance) for logging messages and controlling how those messages are presented to the user. </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="ab9bf77d271bae9aa6b904d4b71a0038b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab9bf77d271bae9aa6b904d4b71a0038b">&#9670;&nbsp;</a></span>Level</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">OpenSim::Logger::Level</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This enum lists the types of messages that should be logged. </p>
<p>These levels match those of the spdlog logging library that <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> uses for logging. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ab9bf77d271bae9aa6b904d4b71a0038bad15305d7a4e34e02489c74a5ef542f36"></a>Off&#160;</td><td class="fielddoc"><p>Do not log any messages. </p>
<p>Useful when running an optimization or automated pipeline. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab9bf77d271bae9aa6b904d4b71a0038ba278d01e5af56273bae1bb99a98b370cd"></a>Critical&#160;</td><td class="fielddoc"><p>Only log critical errors. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab9bf77d271bae9aa6b904d4b71a0038ba902b0d55fddef6f8d651fe1035b7d4bd"></a>Error&#160;</td><td class="fielddoc"><p>Log all messages that require user intervention. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab9bf77d271bae9aa6b904d4b71a0038ba56525ae64d370c0b448ac0d60710ef17"></a>Warn&#160;</td><td class="fielddoc"><p>Log warnings. </p>
<p>Warnings are generated when the software will proceed but the user should check their input. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab9bf77d271bae9aa6b904d4b71a0038ba4059b0251f66a18cb56f544728796875"></a>Info&#160;</td><td class="fielddoc"><p>Default. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab9bf77d271bae9aa6b904d4b71a0038baa603905470e2a5b8c13e96b579ef0dba"></a>Debug&#160;</td><td class="fielddoc"><p>Log information that may be useful when debugging the operation of the software to investigate unexpected results. </p>
</td></tr>
<tr><td class="fieldname"><a id="ab9bf77d271bae9aa6b904d4b71a0038badd4ec0ac4e58f7c32a01244ae91150b1"></a>Trace&#160;</td><td class="fielddoc"><p>Log as much as possible, including messages that describe the software's behavior step by step. </p>
<p>Note: <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> has very few Trace-level messages. </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a3dcb06837a4266a621f7609c7ae9f063"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3dcb06837a4266a621f7609c7ae9f063">&#9670;&nbsp;</a></span>Logger()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OpenSim::Logger::Logger </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">delete</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This is a static singleton class: there is no way of constructing it. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ada23d4a22bda1b8c8720467340705390"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada23d4a22bda1b8c8720467340705390">&#9670;&nbsp;</a></span>addFileSink()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::addFileSink </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>filepath</em> = <code>&quot;opensim.log&quot;</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Log messages to a file at the level <a class="el" href="classOpenSim_1_1Logger.html#aca506597a87dafa7d5af8451377a7da6">getLevel()</a>. </p>
<p><a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> logs messages to the file opensim.log by default. If we are already logging messages to a file, then this function issues a warning and returns; invoke <a class="el" href="classOpenSim_1_1Logger.html#acd269e7508f0a8d41002db2bd5e2758b" title="Remove the filesink if it exists.">removeFileSink()</a> first. </p><dl class="section note"><dt>Note</dt><dd>This function is not thread-safe. Do not invoke this function concurrently, or concurrently with <a class="el" href="classOpenSim_1_1Logger.html#aa6abb842a363b6e596d5a2748f5f19f1" title="Start reporting messages to the provided sink.">addSink()</a> or <a class="el" href="classOpenSim_1_1Logger.html#a4ed6dc7413d3bd5f1a1e61e54db4ffa8" title="Remove a sink.">removeSink()</a>. </dd>
<dd>
If filepath can't be opened, no log file is created. </dd></dl>

</div>
</div>
<a id="aa6abb842a363b6e596d5a2748f5f19f1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa6abb842a363b6e596d5a2748f5f19f1">&#9670;&nbsp;</a></span>addSink()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::addSink </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classOpenSim_1_1LogSink.html">LogSink</a> &gt;&#160;</td>
          <td class="paramname"><em>sink</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Start reporting messages to the provided sink. </p>
<dl class="section note"><dt>Note</dt><dd>This function is not thread-safe. Do not invoke this function concurrently, or concurrently with addLogFile() or <a class="el" href="classOpenSim_1_1Logger.html#a4ed6dc7413d3bd5f1a1e61e54db4ffa8" title="Remove a sink.">removeSink()</a>. </dd></dl>

</div>
</div>
<a id="a79ed78dd4d35d61dded99abc5bbe385f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a79ed78dd4d35d61dded99abc5bbe385f">&#9670;&nbsp;</a></span>cout()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::cout </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Use this function to log messages that would normally be sent to std::cout. </p>
<p>These messages always appear, and are also logged to the filesink (<a class="el" href="classOpenSim_1_1Logger.html#ada23d4a22bda1b8c8720467340705390" title="Log messages to a file at the level getLevel().">addFileSink()</a>) and any sinks added via <a class="el" href="classOpenSim_1_1Logger.html#aa6abb842a363b6e596d5a2748f5f19f1" title="Start reporting messages to the provided sink.">addSink()</a>. The main use case for this function is inside of functions whose intent is to print information (e.g., Component::printSubcomponentInfo()). Besides such use cases, this function should be used sparingly to give users control over what gets logged. </p>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Logger.html#a4f653d7d131bf90fe00c293b9cfd9d26">log_cout()</a>.</p>

</div>
</div>
<a id="a8ae1892878df36703af38b369b11e0ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8ae1892878df36703af38b369b11e0ca">&#9670;&nbsp;</a></span>critical()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::critical </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Logger.html#ad5a89a3ecbe0b1a88eae7dccf73af2b0">log_critical()</a>.</p>

</div>
</div>
<a id="aa471cfeb37b39908214760efb4c45446"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa471cfeb37b39908214760efb4c45446">&#9670;&nbsp;</a></span>debug()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::debug </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Logger.html#ae68b6746c2a1650da00a270e54334bd3">log_debug()</a>.</p>

</div>
</div>
<a id="a250f3b0db87ffb351e1922d6ddfa4952"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a250f3b0db87ffb351e1922d6ddfa4952">&#9670;&nbsp;</a></span>error()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::error </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Logger.html#ab56a381bdaf340f6bc58ab73a67de4a8">log_error()</a>.</p>

</div>
</div>
<a id="aca506597a87dafa7d5af8451377a7da6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aca506597a87dafa7d5af8451377a7da6">&#9670;&nbsp;</a></span>getLevel()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">Level</a> OpenSim::Logger::getLevel </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aa4f14f9ad998e048cda9beddfc7d088f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa4f14f9ad998e048cda9beddfc7d088f">&#9670;&nbsp;</a></span>getLevelString()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::string OpenSim::Logger::getLevelString </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a686643c76023df13e6e21e9006ed2c8a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a686643c76023df13e6e21e9006ed2c8a">&#9670;&nbsp;</a></span>info()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::info </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Logger.html#ac4d15dcdc1d233ba73afca5adfcc7cd2">log_info()</a>.</p>

</div>
</div>
<a id="acd269e7508f0a8d41002db2bd5e2758b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acd269e7508f0a8d41002db2bd5e2758b">&#9670;&nbsp;</a></span>removeFileSink()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::removeFileSink </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Remove the filesink if it exists. </p>
<p>If the filesink was already removed, then this does nothing. </p><dl class="section note"><dt>Note</dt><dd>This function is not thread-safe. Do not invoke this function concurrently, or concurrently with <a class="el" href="classOpenSim_1_1Logger.html#aa6abb842a363b6e596d5a2748f5f19f1" title="Start reporting messages to the provided sink.">addSink()</a> or <a class="el" href="classOpenSim_1_1Logger.html#a4ed6dc7413d3bd5f1a1e61e54db4ffa8" title="Remove a sink.">removeSink()</a>. </dd></dl>

</div>
</div>
<a id="a4ed6dc7413d3bd5f1a1e61e54db4ffa8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4ed6dc7413d3bd5f1a1e61e54db4ffa8">&#9670;&nbsp;</a></span>removeSink()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::removeSink </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classOpenSim_1_1LogSink.html">LogSink</a> &gt;&#160;</td>
          <td class="paramname"><em>sink</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Remove a sink. </p>
<p>If it doesn't exist, do nothing. </p><dl class="section note"><dt>Note</dt><dd>This function is not thread-safe. Do not invoke this function concurrently, or concurrently with addLogFile() or <a class="el" href="classOpenSim_1_1Logger.html#aa6abb842a363b6e596d5a2748f5f19f1" title="Start reporting messages to the provided sink.">addSink()</a>. </dd></dl>

</div>
</div>
<a id="aebdf27ba090612d28271dfcd74e2944a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aebdf27ba090612d28271dfcd74e2944a">&#9670;&nbsp;</a></span>setLevel()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::setLevel </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">Level</a>&#160;</td>
          <td class="paramname"><em>level</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Log messages of importance <code>level</code> and greater. </p>
<p>For example, if the level is set to Info, then Critical, Error, Warn, and Info messages are logged, while Debug and Trace messages are not logged. </p>

</div>
</div>
<a id="a4cb7dc306a537291f77996c207bc20d3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4cb7dc306a537291f77996c207bc20d3">&#9670;&nbsp;</a></span>setLevelString()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::setLevelString </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>level</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p><a class="el" href="classOpenSim_1_1Set.html" title="A class for holding a set of pointers to objects.">Set</a> the logging level using one of the following strings (case-insensitive): </p>
<ul>
<li>Off</li>
<li>Critical</li>
<li>Error</li>
<li>Warn</li>
<li>Info</li>
<li>Debug</li>
<li>Trace This variant of <a class="el" href="classOpenSim_1_1Logger.html#aebdf27ba090612d28271dfcd74e2944a" title="Log messages of importance level and greater.">setLevel()</a> is for use in Matlab. <dl class="section see"><dt>See also</dt><dd><a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b" title="This enum lists the types of messages that should be logged.">Level</a>. </dd></dl>
</li>
</ul>

</div>
</div>
<a id="ae2208167a9d1c1b48ed4e54a161d679a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae2208167a9d1c1b48ed4e54a161d679a">&#9670;&nbsp;</a></span>shouldLog()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static bool OpenSim::Logger::shouldLog </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Logger.html#ab9bf77d271bae9aa6b904d4b71a0038b">Level</a>&#160;</td>
          <td class="paramname"><em>level</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns true if messages at the provided level should be logged, based on the set logging level. </p>
<p>The following code will produce output: </p><div class="fragment"><div class="line">Log::setLevel(Log::Level::Warn);</div>
<div class="line"><span class="keywordflow">if</span> (<a class="code" href="classOpenSim_1_1Logger.html#ae2208167a9d1c1b48ed4e54a161d679a">shouldLog</a>(Log::Level::Error)) {</div>
<div class="line">    std::cout &lt;&lt; <span class="stringliteral">&quot;Error encountered.&quot;</span> &lt;&lt; std::endl;</div>
<div class="line">}</div>
<div class="ttc" id="aclassOpenSim_1_1Logger_html_ae2208167a9d1c1b48ed4e54a161d679a"><div class="ttname"><a href="classOpenSim_1_1Logger.html#ae2208167a9d1c1b48ed4e54a161d679a">OpenSim::Logger::shouldLog</a></div><div class="ttdeci">static bool shouldLog(Level level)</div><div class="ttdoc">Returns true if messages at the provided level should be logged, based on the set logging level.</div></div>
</div><!-- fragment --> 
</div>
</div>
<a id="ad981c195465d109877d26430dc93f13a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad981c195465d109877d26430dc93f13a">&#9670;&nbsp;</a></span>trace()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::trace </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Logger.html#ae48973bbd459ae7f2e3f3644a798028e">log_trace()</a>.</p>

</div>
</div>
<a id="a9fb1e1e532b51620a732cee20f008ec6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9fb1e1e532b51620a732cee20f008ec6">&#9670;&nbsp;</a></span>warn()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::Logger::warn </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1Logger.html#a83e8a51160dc02d15543381e38405651">log_warn()</a>.</p>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a4f653d7d131bf90fe00c293b9cfd9d26"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4f653d7d131bf90fe00c293b9cfd9d26">&#9670;&nbsp;</a></span>log_cout()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void log_cout </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Use this function to log messages that would normally be sent to std::cout. </p>
<p>These messages always appear, and are also logged to the filesink (<a class="el" href="classOpenSim_1_1Logger.html#ada23d4a22bda1b8c8720467340705390" title="Log messages to a file at the level getLevel().">addFileSink()</a>) and any sinks added via <a class="el" href="classOpenSim_1_1Logger.html#aa6abb842a363b6e596d5a2748f5f19f1" title="Start reporting messages to the provided sink.">addSink()</a>. The main use case for this function is inside of functions whose intent is to print information (e.g., Component::printSubcomponentInfo()). Besides such use cases, this function should be used sparingly to give users control over what gets logged. </p>

<p class="reference">References <a class="el" href="classOpenSim_1_1Logger.html#a79ed78dd4d35d61dded99abc5bbe385f">cout()</a>.</p>

</div>
</div>
<a id="ad5a89a3ecbe0b1a88eae7dccf73af2b0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5a89a3ecbe0b1a88eae7dccf73af2b0">&#9670;&nbsp;</a></span>log_critical()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void log_critical </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1Logger.html#a8ae1892878df36703af38b369b11e0ca">critical()</a>.</p>

</div>
</div>
<a id="ae68b6746c2a1650da00a270e54334bd3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae68b6746c2a1650da00a270e54334bd3">&#9670;&nbsp;</a></span>log_debug()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void log_debug </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1Logger.html#aa471cfeb37b39908214760efb4c45446">debug()</a>.</p>

</div>
</div>
<a id="ab56a381bdaf340f6bc58ab73a67de4a8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab56a381bdaf340f6bc58ab73a67de4a8">&#9670;&nbsp;</a></span>log_error()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void log_error </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1Logger.html#a250f3b0db87ffb351e1922d6ddfa4952">error()</a>.</p>

</div>
</div>
<a id="ac4d15dcdc1d233ba73afca5adfcc7cd2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac4d15dcdc1d233ba73afca5adfcc7cd2">&#9670;&nbsp;</a></span>log_info()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void log_info </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1Logger.html#a686643c76023df13e6e21e9006ed2c8a">info()</a>.</p>

</div>
</div>
<a id="ae48973bbd459ae7f2e3f3644a798028e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae48973bbd459ae7f2e3f3644a798028e">&#9670;&nbsp;</a></span>log_trace()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void log_trace </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1Logger.html#ad981c195465d109877d26430dc93f13a">trace()</a>.</p>

</div>
</div>
<a id="a83e8a51160dc02d15543381e38405651"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83e8a51160dc02d15543381e38405651">&#9670;&nbsp;</a></span>log_warn()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename... Args&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void log_warn </td>
          <td>(</td>
          <td class="paramtype">spdlog::string_view_t&#160;</td>
          <td class="paramname"><em>fmt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const Args &amp;...&#160;</td>
          <td class="paramname"><em>args</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">related</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="reference">References <a class="el" href="classOpenSim_1_1Logger.html#a9fb1e1e532b51620a732cee20f008ec6">warn()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Common/Logger.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1Logger.html">Logger</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:23 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
